/* Letters.h V.01 By Gaz Davidson        */
/* For use in some kind of 3d scrolly... */


struct letter
{
  int              numpoints;
  struct _3dcoords *points;
  struct letter    *next;
};

void          drawletter   (struct letter    *myletter,
			    struct _3dcoords *offset,
			    struct _3dcoords *rotation,
			    struct coords    *midscreen,
			    float            zoom,
			    float            aspect);

struct letter *loadletters (FILE *input);


void          drawletter   (struct letter    *myletter,
			    struct _3dcoords *offset,
			    struct _3dcoords *rotation,
			    struct coords    *midscreen,
			    float            zoom,
			    float            aspect)
{
 
 struct _3dcoords xyz[40];
 int n;

 for (n=0;n<myletter->numpoints;n++)
 {
  xyz[n].x=myletter->points[n].x;
  xyz[n].y=myletter->points[n].y;
  xyz[n].z=myletter->points[n].z;
 }

 _3drotate (myletter->numpoints,xyz,rotation->x,rotation->y,rotation->z);
 draw3d    (myletter->numpoints,xyz,offset,midscreen,zoom,aspect);

}

void          put3dtext    (char             *text,
			    struct letter    *first,
			    struct _3dcoords *offset,
			    struct _3dcoords *rotation,
			    struct coords    *middle,
			    float            zoom,
			    float            aspect)
{
 float            x;
 struct _3dcoords swap;
 struct letter    *current;
 int              size,
		  n,m,data;

 size   = strlen(text);

 x=0-(120*(size/2));

 n=0;
 while(n<size)
 {
  current=first;
  data=-1;
  if (text[n]>='a' && text[n]<='z') data = (int)(text[n]-'a');
  if (text[n]>='A' && text[n]<='Z') data = (int)(text[n]-'A');
  if (data!=-1)
  {
     swap.x=x; swap.y=0; swap.z=0;
    _3drotate(1,           &swap,
	      rotation->x, rotation->y,
	      rotation->z);
    swap.x+=offset->x;
    swap.y+=offset->y;
    swap.z+=offset->z;

    m=0;
    while (m!=data)
    {
      current=current->next;
      m++;
    }

    drawletter   (current,
		  &swap,
		  rotation,
		  middle,
		  zoom,
		  aspect);

  }
  x=x+120;
  n++;

 }

}

struct letter *loadletters (FILE *input)
{
 struct _3dcoords *data;
 struct letter    *first,  *current;
 int              count, n, m;
 float            swap;

 if (!(first=(struct letter *)malloc(sizeof(struct letter)) ))
	return (NULL); 				/* create a letter       */
 current=first;                                 /* make it the first one */

 swap=getvalue(input);          /* collect and store the */
 count=(int)swap;               /* number of letters so far */

 n=0;

 while (n<count)                /* do this for each letter */
 {

  swap=getvalue(input);         /* collect */
  current->numpoints=(int)swap; /* and store the number of points */

  if (!(current->points=(struct _3dcoords *)malloc(sizeof(struct _3dcoords)*current->numpoints)))
     return (NULL);             /* make some new data */

  m=0;
  data=current->points;         /* point to the first point */

  while (m<current->numpoints)  /* do this for each point    */
  {
   data[m].x = getvalue(input); /* collect and store x value */
   data[m].y = getvalue(input); /* collect and store y value */
   data[m].z = 0;               /* Z value is always 0       */

   m++;                         /* move to next point        */
  }

  n++;

  if (n<count)
  {
   if (!(current->next=(struct letter*)malloc(sizeof(struct letter)) ))
   {
     n=count;
     current->next=NULL;
   }
   current=current->next;
  }

 }
 current->next=NULL;

 return (first);

}