/* 
Rotate.h VER$:0.03b Gaz Davidson 1999 

History of Changes: 
   
 0.01b to 0.02b

   Fixed division by 0 error if hypotenuse is 0 in rotate function

   Added _3dcoords structure for 3d polys 
   Added _3dto2d  function for 3d to 2d coord conversion
   Added _3drotate function
   Added draw3d function for drawing 3d polygons

 0.02b to 0.03b
   
   Fixed aspect problem in _3dto2d function

*/ 


/* Try to remember...                          */
/* PI   radians = 360 degrees,                 */
/* 1 degrees    = 0.00873 radians              */
/* Tan = Opp/Adj, Sin = Opp/Hyp, Cos = Adj/Hyp */


struct coords
{
   float x;
   float y;
};

struct _3dcoords
{
   float x;
   float y;
   float z;
};


void  rotate    (struct coords    *these,    
		 float            radians);  

void  _3dto2d   (struct _3dcoords *points,   
		 struct coords    *mynew,     
		 float            zoom,
		 float            aspect);

void  _3drotate (int              number,
		 struct _3dcoords *points,
		 float            xrot,
		 float            yrot,
		 float            zrot);

void draw3d     (int              number, 
		 struct _3dcoords *points,
		 struct _3dcoords *offset,
		 struct coords    *midscreen,
		 float            zoom,
		 float            aspect);


void  rotate    (struct coords    *these,
		 float            radians)
{           

  float h = hypot(these->x,these->y);   /* find the hypotenuse */
  float angle;                          
  int yuk=0;
	       
  if (h==0) return;                     /* h can`t be 0!       */               

  if (these->y<0)                       /* are we going backwards? */
  {
     these->y=0-these->y;                  
     radians=0-radians;
     yuk=1;                                 /* remember we are!    */
  }

  angle = asin(these->x/h);             /* find the angle      */
  angle = angle+radians;                /* change the angle    */

  these->x = h * sin(angle);            /* find the new x      */
  these->y = h * cos(angle);            /* find the new y      */


  if (yuk==1)                           /* did we go backwards? */
      these->y=0-these->y;              /* put it back...       */
}           

void  _3dto2d  (struct _3dcoords  *points,
		struct coords     *mynew,
		float             zoom,
		float             aspect)
{
   float newzoom=zoom;    

   aspect=aspect*zoom;

   newzoom=newzoom+(points->z*aspect); /* move in or out (set by Z)   */
   if (newzoom<0) newzoom=0;           /* make sure newzoom is over 0 */ 
   mynew->x=points->x*newzoom;         /* set the new X value         */
   mynew->y=points->y*newzoom;         /* and the new Y value         */

}


void  _3drotate (int               number,
		 struct _3dcoords  *points,
		 float             xrot,
		 float             yrot,
		 float             zrot)
{
 struct coords rot2d;  /* rotation order is z,x,y */
 int           n=0;

 while (n<number)
 {
		       /* rotation on z = x and y */
    rot2d.x   = points->x; rot2d.y = points->y; rotate (&rot2d,zrot);
    points->x = rot2d.x; points->y = rot2d.y;

		       /* rotation on x = z and y */

    rot2d.x   = points->z; rot2d.y = points->y; rotate (&rot2d,xrot);
    points->z = rot2d.x; points->y = rot2d.y;

		       /* rotation on y = x and z  */

    rot2d.x   = points->x; rot2d.y = points->z; rotate (&rot2d,yrot);
    points->x = rot2d.x; points->z = rot2d.y;

    n++;
    points++;
 }
}

void draw3d     (int               number, 
		 struct _3dcoords  *points,
		 struct _3dcoords  *offset,
		 struct coords     *midscreen,
		 float             zoom,
		 float             aspect)
{
 struct _3dcoords _3dswap;
 struct coords    _2dswap;
 int              poly[42],n=0,j;

 if (number>20)                          /* Can`t have over 20 points */
     number=20;
 
 while(n<number)                        /* do the loop for each point */
 {
  _3dswap.x = points->x + offset->x;           /* add the offset to x */
  _3dswap.y = points->y + offset->y;           /* add the offset to y */
  _3dswap.z = points->z + offset->z;           /* add the offset to z */
  
  _3dto2d(&_3dswap,&_2dswap,zoom,aspect);   /* convert 3d point to 2d */
  j=n*2;
  poly[j]    = (int)(_2dswap.x + midscreen->x);   /* store x position */
  poly[j+1]  = (int)(_2dswap.y + midscreen->y);   /* store y position */

  points++;                          /* move pointer to next 3d point */
  n++;                                     /* increment point counter */      
 }

 fillpoly (number,poly);                /* draw the polygon on screen */

}
